% A depth-first search interpreter.

module dfs.

import lists maptac.

type app_tac            list (goal -> goal -> o) -> goal -> goal -> o.
type dfs                list (goal -> goal -> o) -> goal -> goal -> o.
type dfs_interp         list (goal -> goal -> o) -> goal -> o.


app_tac (Tac::Rest) InGoal OutGoal :- Tac InGoal OutGoal.
app_tac (Tac::Rest) InGoal OutGoal :- app_tac Rest InGoal OutGoal.

dfs Tacs InGoal OutGoal :- app_tac Tacs InGoal MidGoal,
                           maptac (dfs Tacs) MidGoal OutGoal.

dfs_interp Tacs InGoal :- maptac (dfs Tacs) InGoal OutGoal.
