module goals.

% This module contains the type declarations for building 
% goal expressions.

kind    goal    type.

type    tt      goal.
type    ff      goal.
type    '&&'    goal -> goal -> goal.
type    'vv'    goal -> goal -> goal.
type    all     (A -> goal) -> goal.
type    some    (A -> goal) -> goal.
type    '==>>'  A -> goal -> goal.
