module maptac.

import goals.

type    maptac  (goal -> goal -> o) -> goal -> goal -> o.
type    memo    A -> o.

maptac Tac tt tt.

maptac Tac (InGoal1 && InGoal2) (OutGoal1 && OutGoal2) :-
  maptac Tac InGoal1 OutGoal1, maptac Tac InGoal2 OutGoal2.

maptac Tac (all InGoal) (all OutGoal) :-
  pi T\ (maptac Tac (InGoal T) (OutGoal T)).

maptac Tac (InGoal1 vv InGoal2) OutGoal :-
  maptac Tac InGoal1 OutGoal; maptac Tac InGoal2 OutGoal.

maptac Tac (some InGoal) OutGoal :-
  sigma T\ (maptac Tac (InGoal T) OutGoal).

maptac Tac (D ==>> InGoal) (D ==>> OutGoal) :-
  (memo D) => (maptac Tac InGoal OutGoal).

maptac Tac InGoal OutGoal :- Tac InGoal OutGoal.
