module ndc.

%% Test examples for proof by analogy.

import ndcopy.
import formulas nprfex.

testcopy Tac Name1 Name2 F1 P1 F2 P2 GOutGoal TOutGoal :-
  formula Name1 F1,
  proofex Name1 P1,
  formula Name2 F2,
  Tac (nil --> P1 # F1) GOutGoal (nil --> P2 # F2) TOutGoal.

testcopy1 F1 P1 F2 P2 OutGoal1 OutGoal2 :-
  testcopy exactcopy distrib_quant1 distrib_quant2
           F1 P1 F2 P2 OutGoal1 OutGoal2.

testcopy2 F1 P1 F2 P2 OutGoal1 OutGoal2 :-
  testcopy orcopy distrib_quant2 distrib_quant3 F1 P1 F2 P2 OutGoal1 OutGoal2.

testcopy3 F1 P1 F2 P2 OutGoal1 OutGoal2 :-
  testcopy exactcopy cases2 cases3 F1 P1 F2 P2 OutGoal1 OutGoal2.

testcopy4 F1 P1 F2 P2 OutGoal1 OutGoal2 :-
  testcopy orcopy cases2 cases3 F1 P1 F2 P2 OutGoal1 OutGoal2.
