
module suicide.

import metaebg.

kind man	type.
kind thing	type.

type hate	man -> man -> o.
type possess	man -> object -> o.
type weapon     object -> o.
type kill	man -> man -> o.
type depressed  man -> o.
type buy        man -> object -> o.
type gun	object -> o.




hyp (box ((pi A\ (pi B\ (pi C\ 
       (((hate A B), (possess A C), (weapon C)) => (kill A B))))))).
hyp (box (pi W\ ((depressed(W) => hate W W)))).
hyp (box (pi U\ (pi V\ ((buy U V) => (possess U V))))).
hyp (box (pi Z\ ((gun Z) => (weapon Z)))).
hyp (depressed john).
hyp (buy john gun1).
hyp (gun gun1).






%% Standard query

% dosolve (kill john john) GG DD.





%%  Test examples.

suic_1 G GG DD:- 
 G = (kill john john),
 dosolve G GG DD .


%  ?- suic_1 G GG DD.
%  Solving . . .
%  G == kill john john
%  GG == kill Y Y
%  DD == depressed Y , buy Y Y1 , gun Y1
%  no more solutions
