%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%        mini-ML: Examples                              %%%
%%%        Examples for testing type inferencing          %%%
%%%            and evaluator.                             %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

module mltest.

import mltype mleval mlexam.



%%% TEST CASES %%%
test1 T :- fact1 F, infer F T.
test2 T :- fact1 F, infer (let Fact\(@ Fact (# 3)) F) T.
test3 V :- fact1 F, eval  (let Fact\(@ Fact (# 3)) F) V.
test4 T :- app1 A,  infer A T.
test5 T :- app1 A,  l12 L12, l34 L34,
		    infer (let App\(@ (@ App L12) L34) A)  T.
test6 V :- app1 A,  l12 L12, l34 L34,
		    eval (let App\(@ (@ App L12) L34) A)  V.
test7 T :- evenodd1 F, infer F T.
test8 V :- evenodd1 F, eval (let EO\(@(@ fst EO) (# 3)) F) V.

%%%   End of module mltest   %%%

