%%% This module contains (sometimes almost) equivalent definitions
%%% of primitives or specials.

module "prims".

%%% Logical primitves solely in terms of => and pi.

',*' G1 G2 :- pi g \ ((g :- G2 :- G1) => g).

';*' G1 G2 :- pi g \ ((g :- G1) => (g :- G2) => g).

sigma* G :- pi g \ ((pi X \ (g :- G X)) => g).

true* :- pi g \ (g => g).

fail* :- pi g \ g.

%%% Next list of alternatives somewhat simpler.

',**' G1 G2 :- G2 :- G1.

';**' G1 G2 :- G1.
';**' G1 G2 :- G2.

sigma** G :- G X.

true**.

% fail** is simply absent.

%%% Others.

'=*' M M.

once* G :- pi g \ ((g :- G, !) => g).
