%%% A signature for the untyped lambda-calculus with natural numbers
%%% and iteration over them as primitive.  This is the target of
%%% compilation for the pure second-order polymorphic lambda calculus.
%%% Author: fp.

module lamsig.

kind	term		type.

type	lam		(term -> term) -> term.
type	app		term -> term -> term.

type	*zero*		term.
type	*succ*		term.
type	*iternat*	term.
