module sub1.

import substaux.

type	subst1	(tm -> tm) -> tm -> tm -> o.
doc subst1 "``Unfolds'' unification problem of subst0 based on signature of language.".

subst1 X\X Q Q.
subst1 X\Y Q Y :- !.

subst1 X\(app (M X) (N X)) Q (app P R) :-
	subst1 M Q P,
	subst1 N Q R.

subst1 X\(abs (H X)) Q (abs M) :-
	pi Z\ (subst1 X\(H X Z) Q (M Z)).