module substa.

import substaux.

type subst	(tm -> tm) -> tm -> tm -> o.
type copy	tm -> tm -> o.

doc subst "(subst \x.P Q R) if R = P[x:=Q].".
doc copy  "(copy P Q) rewrites P into Q.".

subst  M P Q :- pi X\(copy X P  =>  copy (M X) Q).

copy (app P Q) (app R S) :-
	copy P R,  copy Q S.

copy (abs M) (abs N) :-
	pi X\(pi Y\((copy X Y) => copy (M X) (N Y))).

copy P P.
