;;; -*- Mode: Lisp; Package: ELP -*-
;;;
;;; Syntactic ADTs for LP modules
;;;
;;; Author: Conal Elliott.  Last Modified Mon Sep 11 06:08:48 1989
;;;
;;; Sccs Id @(#)smodule.lisp	1.23 9/15/89
;;; ******************************************************************* ;;;
;;;         (c) Copyright 1989 by Carnegie Mellon University.           ;;;
;;;                        All rights reserved.                         ;;;
;;;         This code was written as part of the Ergo project.          ;;;
;;;  If you want to use this code or any Ergo software, please contact  ;;;
;;;			Frank Pfenning (fp@cs.cmu.edu)			;;;
;;; ******************************************************************* ;;;


(in-package :ELP) (use-package :ergolisp)

(defsconstr "

    DATATYPE Smodentry =
       Mkinding of Symbol, Skind
     | Mtyping of Symbol, Stype
     | Mindexing of Symbol, Nat
     | Msdform of Sterm

    DATATYPE Smodule of
       name : String ,
       imports : String* ,
       entries : Modentry*
")
