module lprf.

%  This file is the "signature" file for building sequent-style proofs.
%  Proofs include substitution instances.

import fol.

kind    lprf            type.

type    initial         form -> lprf.
type    and_l           lprf -> lprf.
type    and_r           lprf -> lprf -> lprf.
type    or_l            lprf -> lprf -> lprf.
type    or_r            lprf -> lprf.
type    or_r1           lprf -> lprf.
type    or_r2           lprf -> lprf.
type    imp_r           lprf -> lprf.
type    imp_l           lprf -> lprf -> lprf.
type    neg_r           lprf -> lprf.
type    neg_l           lprf -> lprf.
type    exists_r        i -> lprf -> lprf.
type    exists_l        (i -> lprf) -> lprf.
type    forall_r        (i -> lprf) -> lprf.
type    forall_l        i -> lprf -> lprf.
type    false_r         lprf -> lprf.
type    cut             lprf -> lprf -> lprf.
