module nprfex.

import nprf formulas.

type    proofex         name -> nprf -> o.

proofex distrib_quant1
  (imp_i P\ (or_e (forall X\ (q X)) y P 
                  P1\ (forall_i Y\ (or_i1 (forall_e Y X\ (q X) P1)))
                  P2\ (forall_i Y\ (or_i2 P2)))).

proofex distrib_quant2
  (imp_i P\ (or_e (forall X\ (q X)) z P
                  P1\ (forall_i Y\ (or_i1 (forall_e Y X\ (q X) P1)))
                  P2\ (forall_i Y\ (or_i2 P2)))).

proofex distrib_quant3
  (imp_i P\ (and_i (forall_i Y\ (and_e1 z (forall_e Y X\ (q X and z) P)))
                   (and_e2 (q T) (forall_e T X\ (q X and z) P)))).

proofex cases2
  (imp_i P\ (or_e (p a) (q b) (and_e1 (forall X\ (p X imp q X)) P)
                  P1\ (exists_i a (imp_e (p a) P1 (forall_e a X\ (p X imp q X)
                                                   (and_e2 (p a or q b) P))))
                  P2\ (exists_i b P2))).
