module ebg_fol.

%  This module provides the "signature" for a simple, first-order
%  (object) logic.

%infix   110 and xfy.
%infix   110 or  xfy.
%infix   120 imp xfy.

kind    i       type.
kind    bool    type.

type    'and'   bool -> bool -> bool.
type    'or'    bool -> bool -> bool.
type    'imp'   bool -> bool -> bool.
type    neg     bool -> bool.
type    forall  (i -> bool) -> bool.
type	exists  (i -> bool) -> bool.
type    false   bool.
