module sub2.

import substaux.

type	subst2	(tm -> tm) -> tm -> tm -> o.
doc	subst2  "Expands 4th clause of subst1 using fact that subst0=subst1.".

subst2 X\X Q Q.
subst2 X\Y Q Y :- !.

subst2 X\(app (M X) (N X)) Q (app P R) :-
	subst2 M Q P,
	subst2 N Q R.

subst2 X\(abs (H X)) Q (abs M) :-
	pi Z\ (pi X\ (subst2 (H X) Z (J X Z)), 
		      subst2 X\(J X Z) Q (M Z)).