module substb.

import substaux.

kind pair	type.

type subst	tm -> tm -> tm -> o.
type copy	(list pair) -> tm -> tm -> o.
type pair	tm -> tm -> pair.

doc subst "(subst \x.P Q R) if R = P[x:=Q].".
doc copy  "(copy L P Q) rewrites P into Q via subsitution L.".

subst (abs M) P Q :- pi X\(copy (cons (pair X P) nil) (M X) Q).


copy Gamma (app P Q) (app R S) :-
	copy Gamma P R,  copy Gamma Q S.

copy Gamma (abs M) (abs N) :-
	pi X\(pi Y\(copy (cons (pair X Y) Gamma) (M X) (N Y))).

copy Gamma C D :-
	member (pair C D) Gamma.
